'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _ImgLazy = require('./../ImgLazy');

var _ImgLazy2 = _interopRequireDefault(_ImgLazy);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var Container = (0, _react.forwardRef)(function (_ref, ref) {
  var lazyLoad = _ref.lazyLoad,
      children = _ref.children,
      others = _objectWithoutProperties(_ref, ['lazyLoad', 'children']);

  var refEl = (0, _react.useRef)(null);
  (0, _react.useImperativeHandle)(ref, function () {
    return refEl.current;
  });

  // 图片懒加载
  var lazyInstance = (0, _react.useRef)(null);
  (0, _react.useEffect)(function () {
    if (lazyLoad !== 'scroll' && lazyLoad !== 'queue') return;
    if (lazyInstance.current) {
      lazyInstance.current.load();
    } else {
      lazyInstance.current = new _ImgLazy2.default({
        overflowContainer: refEl.current,
        load: lazyLoad
      });
      lazyInstance.current.load();
    }
  }, [children]); // eslint-disable-line

  return _react2.default.createElement(
    'article',
    _extends({ ref: refEl }, others, { className: 'container' + (others.className ? ' ' + others.className : '') }),
    children
  );
});

exports.default = Container;
module.exports = exports['default'];