'use strict';

exports.__esModule = true;
exports.default = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _class, _temp;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _instance = require('./instance');

var _instance2 = _interopRequireDefault(_instance);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var InputRange = (_temp = _class = function (_Component) {
  _inherits(InputRange, _Component);

  function InputRange(props) {
    _classCallCheck(this, InputRange);

    var _this = _possibleConstructorReturn(this, _Component.call(this, props));

    _this.onChange = function (e) {
      if (_this.props.onChange) {
        _this.props.onChange(e, _this.$input.value);
      }
    };

    return _this;
  }

  InputRange.prototype.componentDidMount = function componentDidMount() {
    this.instance = new _instance2.default(this.$el, {
      onChange: this.onChange(e)
    });
  };

  InputRange.prototype.render = function render() {
    var _this2 = this;

    var _props = this.props,
        value = _props.value,
        min = _props.min,
        max = _props.max,
        step = _props.step,
        disabled = _props.disabled,
        _props$inputAttribute = _props.inputAttribute,
        inputAttribute = _props$inputAttribute === undefined ? {} : _props$inputAttribute,
        _props$tooltipAttribu = _props.tooltipAttribute,
        tooltipAttribute = _props$tooltipAttribu === undefined ? {} : _props$tooltipAttribu,
        onChange = _props.onChange,
        others = _objectWithoutProperties(_props, ['value', 'min', 'max', 'step', 'disabled', 'inputAttribute', 'tooltipAttribute', 'onChange']);

    return _react2.default.createElement(
      'div',
      _extends({ ref: function ref(el) {
          _this2.$el = el;
        } }, others, { className: 'range' + (others.className ? ' ' + others.className : '') }),
      _react2.default.createElement('input', _extends({ ref: function ref(el) {
          _this2.$input = el;
        } }, inputAttribute, { disabled: disabled, type: 'range', className: 'range-input' + (inputAttribute.className ? ' ' + inputAttribute.className : ''), min: min, max: max, step: step, defaultValue: value })),
      _react2.default.createElement(
        'div',
        _extends({ ref: function ref(el) {
            _this2.$tooltip = el;
          } }, tooltipAttribute, { className: 'range-tooltip' + (tooltipAttribute.className ? ' ' + tooltipAttribute.className : '') }),
        value
      )
    );
  };

  return InputRange;
}(_react.Component), _class.defaultProps = {
  value: '0',
  min: '0',
  max: '100',
  step: '1'
}, _temp);
exports.default = InputRange;
InputRange.propTypes = process.env.NODE_ENV !== "production" ? {
  value: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.number]),
  min: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.number]),
  max: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.number]),
  step: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.number]),
  disabled: _propTypes2.default.bool,
  inputAttribute: _propTypes2.default.object,
  tooltipAttribute: _propTypes2.default.object,
  onChange: _propTypes2.default.func
} : {};
module.exports = exports['default'];