'use strict';

exports.__esModule = true;
exports.default = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _class, _temp;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _PlayerDialog = require('./PlayerDialog');

var _PlayerDialog2 = _interopRequireDefault(_PlayerDialog);

var _instance = require('../Context/instance.js');

var _instance2 = _interopRequireDefault(_instance);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Player = (_temp = _class = function (_Component) {
  _inherits(Player, _Component);

  function Player(props) {
    _classCallCheck(this, Player);

    var _this = _possibleConstructorReturn(this, _Component.call(this, props));

    _this.state = {
      videoShow: false
    };

    _this.play = function (e, show) {
      _this.setState({
        videoShow: show
      });
      e.stopPropagation();
    };

    return _this;
  }

  Player.prototype.componentDidMount = function componentDidMount() {
    this.$ComponentPlayerDialog = this.refs.$ComponentPlayerDialog;
    this.$video = this.refs.$ComponentPlayerDialog.$el;
  };
  // 显隐视频弹窗


  Player.prototype.render = function render() {
    var _this2 = this;

    var _props = this.props,
        portal = _props.portal,
        src = _props.src,
        _props$maskAttribute = _props.maskAttribute,
        maskAttribute = _props$maskAttribute === undefined ? {} : _props$maskAttribute,
        _props$videoAttribute = _props.videoAttribute,
        videoAttribute = _props$videoAttribute === undefined ? {} : _props$videoAttribute,
        poster = _props.poster,
        children = _props.children,
        others = _objectWithoutProperties(_props, ['portal', 'src', 'maskAttribute', 'videoAttribute', 'poster', 'children']);

    return _react2.default.createElement(
      'div',
      _extends({ ref: function ref(el) {
          _this2.$el = el;
        } }, others, { className: 'player-thumbnail' + (others.className ? ' ' + others.className : ''), onClick: others.onClick ? others.onClick : function (e) {
          return _this2.play(e, true);
        } }),
      poster && _react2.default.createElement('div', { style: { backgroundImage: 'url(' + poster + ')' }, className: 'player-thumbnail-poster' }),
      _react2.default.createElement('div', { className: 'player-thumbnail-button' }),
      children,
      _react2.default.createElement(_PlayerDialog2.default, {
        ref: '$ComponentPlayerDialog',
        show: this.state.videoShow,
        portal: portal,
        src: src,
        maskAttribute: maskAttribute,
        videoAttribute: videoAttribute,
        onHide: function onHide(e) {
          return _this2.play(e, false);
        }
      })
    );
  };

  return Player;
}(_react.Component), _class.contextType = _instance2.default, _class.defaultProps = {}, _temp);
exports.default = Player;
Player.propTypes = process.env.NODE_ENV !== "production" ? {
  portal: _propTypes2.default.object,
  src: _propTypes2.default.string,
  maskAttribute: _propTypes2.default.object,
  videoAttribute: _propTypes2.default.object,
  poster: _propTypes2.default.string,
  children: _propTypes2.default.node
} : {};
module.exports = exports['default'];