'use strict';

exports.__esModule = true;
exports.default = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _class, _temp;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Timeline = (_temp = _class = function (_Component) {
  _inherits(Timeline, _Component);

  function Timeline(props) {
    _classCallCheck(this, Timeline);

    return _possibleConstructorReturn(this, _Component.call(this, props));
  }

  Timeline.prototype.render = function render() {
    var _props = this.props,
        list = _props.list,
        _props$lineAttribute = _props.lineAttribute,
        lineAttribute = _props$lineAttribute === undefined ? {} : _props$lineAttribute,
        _props$badgeAttribute = _props.badgeAttribute,
        badgeAttribute = _props$badgeAttribute === undefined ? {} : _props$badgeAttribute,
        _props$dotAttribute = _props.dotAttribute,
        dotAttribute = _props$dotAttribute === undefined ? {} : _props$dotAttribute,
        others = _objectWithoutProperties(_props, ['list', 'lineAttribute', 'badgeAttribute', 'dotAttribute']);

    if (!list) return null;
    var listDOM = list.map(function (item, index) {
      return _react2.default.createElement(
        'div',
        { key: index, className: 'timeline-case' + (item.active ? ' active' : '') },
        _react2.default.createElement(
          'div',
          _extends({}, badgeAttribute, { className: 'timeline-badge' + (badgeAttribute.className ? ' ' + badgeAttribute.className : '') }),
          item.icon || _react2.default.createElement('i', _extends({}, dotAttribute, { className: 'timeline-dot' + (dotAttribute.className ? ' ' + dotAttribute.className : '') }))
        ),
        item.content,
        item.contentHTML && _react2.default.createElement('div', { dangerouslySetInnerHTML: { __html: item.contentHTML } })
      );
    });
    return _react2.default.createElement(
      'div',
      _extends({}, others, { className: 'timeline' + (others.className ? ' ' + others.className : '') }),
      _react2.default.createElement('span', _extends({}, lineAttribute, { className: 'timeline-line' + (lineAttribute.className ? ' ' + lineAttribute.className : '') })),
      listDOM
    );
  };

  return Timeline;
}(_react.Component), _class.defaultProps = {}, _temp);
exports.default = Timeline;
Timeline.propTypes = process.env.NODE_ENV !== "production" ? {
  list: _propTypes2.default.array, // [{content: node, contentHTML: string, icon: node(默认Dot), active: bool}]

  lineAttribute: _propTypes2.default.object,
  badgeAttribute: _propTypes2.default.object,
  dotAttribute: _propTypes2.default.object
} : {};
module.exports = exports['default'];